/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//				 
//				http://www.interestprograms.ru
//				    ,  
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// TestCMyEditDlg.cpp : implementation file

#include "stdafx.h"
#include "TestCMyEdit.h"
#include "TestCMyEditDlg.h"
#include ".\testcmyeditdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTestCMyEditDlg dialog



CTestCMyEditDlg::CTestCMyEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestCMyEditDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestCMyEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CTestCMyEditDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_SETFONT, OnBnClickedButtonSetfont)
	ON_BN_CLICKED(IDC_BUTTON_COLORBG, OnBnClickedButtonColorbg)
	ON_WM_TIMER()
	ON_WM_CLOSE()

	ON_MESSAGE(WM_MYEDIT_CHANGE, OnChangeCMyEdit)

	ON_WM_CTLCOLOR()
END_MESSAGE_MAP()


// CTestCMyEditDlg message handlers

BOOL CTestCMyEditDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	/////////////////////////////////////////////////////////////////////
	///////////////////      /////////////////////////////

	// ------------   CMyEdit ---------------------------
	m_MyEdit2.CreateMyEdit(CRect(10,10, 160, 42), this);
	m_MyEdit2.SetMyEditFont( 24, 700, "Times New Roman");
	m_MyEdit2.SetWindowText(" ");

	m_MyEdit3.CreateMyEdit(CRect(240,10, 590, 82), this);
	m_MyEdit3.SetMyEditFont( 60, 700, "Arial");
	m_MyEdit3.SetWindowText(" ");


	m_MyEdit1.CreateMyEdit(CRect(10,200, 100, 222), this);
	m_MyEdit1.SetWindowText("Test CMyEdit");

	srand( (unsigned)time( NULL ) );
	SetTimer(ID_TIMER1, 800, NULL);

	



	// -----------        ------------
	m_Brush.CreateSolidBrush(RGB(255,255,0));
	m_Font.CreatePointFont(180, "");
	GetDlgItem(IDC_EDIT1)->SetFont(&m_Font);
	GetDlgItem(IDC_EDIT1)->SetWindowText(" ");

	

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

/*
   
*/
void CTestCMyEditDlg::OnClose()
{
	KillTimer(ID_TIMER1);

	if(m_Font.m_hObject != NULL)
		m_Font.DeleteObject();
	if(m_Brush.m_hObject != NULL)
		m_Brush.DeleteObject();

	CDialog::OnClose();
}

void CTestCMyEditDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestCMyEditDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestCMyEditDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


/*
      CFontDialog
          CMyEdit
*/
void CTestCMyEditDlg::OnBnClickedButtonSetfont()
{
	LOGFONT logfont;
	memset(&logfont, 0, sizeof(LOGFONT));
	m_MyEdit1.GetMyEditFont()->GetLogFont(&logfont);
	CFontDialog dlg(&logfont);
	dlg.m_cf.lStructSize = sizeof(CHOOSEFONT);
	dlg.m_cf.rgbColors = m_MyEdit1.GetColorText();
	
	if(dlg.DoModal() == IDOK)
	{
		//LOGFONT logfont;
		dlg.GetCurrentFont(&logfont);
		m_MyEdit1.SetMyEditFont(&logfont);
		COLORREF color = dlg.GetColor();
		m_MyEdit1.SetColorText(color);

		//     
		//   
		CDC* pDC = GetDC();
		CFont* oldFont = pDC->SelectObject( m_MyEdit1.GetMyEditFont() );
		CString strTemp;
		m_MyEdit1.GetWindowText(strTemp);
		CSize sz_text = pDC->GetTextExtent(strTemp);
		pDC->SelectObject(oldFont);

		ReleaseDC(pDC);

		CRect rc, rc1;
		m_MyEdit1.GetWindowRect(&rc);
		m_MyEdit1.GetClientRect(&rc1);
		int add_x = rc.Width()  - rc1.Width();
		int add_y = rc.Height() - rc1.Height();

		DWORD mar = m_MyEdit1.GetMargins();

		m_MyEdit1.SetWindowPos(NULL, 0,0, 
			sz_text.cx + LOWORD(mar) + HIWORD(mar) + add_x + 2/*     */, 
			sz_text.cy + add_y, 
			SWP_NOMOVE|SWP_NOZORDER);
		
	}
}


/*
        CMyEdit
*/
void CTestCMyEditDlg::OnBnClickedButtonColorbg()
{
	//   
	CColorDialog dlg;
	if(dlg.DoModal() == IDOK)
	{
		COLORREF rgb = dlg.GetColor();
		m_MyEdit1.SetColorBG(rgb);
	}
}

/*
      CMyEdit
     ,  ,     
*/
void CTestCMyEditDlg::OnTimer(UINT nIDEvent)
{
	//    
	COLORREF color_text = RGB( rand()%256, rand()%256, rand()%256);

	//       	
	COLORREF color_bg   = RGB(255 - GetRValue(color_text), 
							  255 - GetGValue(color_text), 
							  255 - GetBValue(color_text));

	//    
	CString s[5] = {"Times New Roman", "Arial", "Microsoft Sans Serif", "Arial Black", "Impact"};

	CString fontname = s[rand()%5];

	m_MyEdit2.SetColorText( color_text );
	m_MyEdit2.SetColorBG( color_bg );
	m_MyEdit2.SetMyEditFont(24, 700, fontname );

	
	m_MyEdit3.SetColorText( color_text );
	m_MyEdit3.SetColorBG( color_bg );
	m_MyEdit3.SetMyEditFont( 60, 700, fontname);


	CDialog::OnTimer(nIDEvent);
}


/*
         
  CMyEdit  
*/

LRESULT CTestCMyEditDlg::OnChangeCMyEdit(WPARAM wParam, LPARAM lParam)
{
	if( (HWND)wParam == m_MyEdit1.m_hWnd)
	{
		CString s;
		m_MyEdit1.GetWindowText(s);
		SetWindowText(s);
	}
	if( (HWND)wParam == m_MyEdit2.m_hWnd)
	{
		CString s;
		m_MyEdit2.GetWindowText(s);
		SetWindowText(s);
	}
	if( (HWND)wParam == m_MyEdit3.m_hWnd)
	{
		CString s;
		m_MyEdit3.GetWindowText(s);
		SetWindowText(s);
	}
	

	return LRESULT();
}

/*
        
*/

HBRUSH CTestCMyEditDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);


	//     
	if( pWnd->GetDlgCtrlID() == IDC_EDIT1)
	{
		pDC->SetBkMode(TRANSPARENT);
		pDC->SetTextColor(RGB(255,0,0));
		
		return m_Brush;
	}

	// TODO:  Return a different brush if the default is not desired
	return hbr;
}
